/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: GED- (bitmap mode)           */
/***************************************/

// Total Eclipse loading picture

dmactls equ $022f
dlptrs	equ $0230
gtictls equ $026f
colpm0s equ $02c0
colpm1s equ $02c1
colpm2s equ $02c2
colpm3s equ $02c3
color0s equ $02C4
color1s equ $02C5
color2s equ $02C6
color3s equ $02C7
color4s equ $02C8
;chact	equ $02f3

	icl "loading.h"

	org $00

zc	.ds ZCOLORS

	org $f0

fcnt	.ds 2
fadr	.ds 2
fhlp	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1

WIDTH	= 40
HEIGHT	= 30

; ---	BASIC switch OFF
	org $2000\ mva #$ff portb\ rts\ ini $2000

; ---	MAIN PROGRAM
	org $2000
scr	ins "loading.raw",+$03c0,$08c0

	org $28c0
	ins "loading.raw",+$1140,$03c0
	
	org $3000
	;ins "loading.raw",+$1140,$0dc0
	ins "loading.raw",+$1500,$0a00
	ins "loading.raw",+$2000,$03c0

	.ifdef nil_used
nil	:8*40 brk
	eif

	.ALIGN $0400
ant	ANTIC_PROGRAM scr,ant

fnt

main
; ---	init PMG

	ift USESPRITES
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	eif

	lda:cmp:req $14		;wait 1 frame

	;sei			;stop interrups
	;mva #$00 nmien		;stop all interrupts
	;mva #$fe portb		;switch off ROM to get 16k more ram

	ZPINIT

////////////////////
// RASTER PROGRAM //
////////////////////

	;jmp raster_program_end

LOOP	lda vcount		;synchronization for the first screen line
	cmp #$02
	bne LOOP

	mva #@dmactl(standard|dma|lineX1|players|missiles) dmactls	;set new screen width
	mva <ant dlptrs
	mva >ant dlptrs+1

; Initial values

c0	lda #$00
	sta colbaks

	lda #$02
	sta chrctl
	lda #$00
	sta gtictls
s0	lda #$00
	sta sizep0
s1	lda #$00
	sta sizep1
s2	lda #$00
	sta sizep2
s3	lda #$00
	sta sizep3
x0	lda #$75
	sta hposp0
x1	lda #$7F
	sta hposp1
x2	lda #$69
	sta hposp2
x3	lda #$8B
	sta hposp3
x4	lda #$7D
	sta hposm0
x5	lda #$87
	sta hposm1
x6	lda #$71
	sta hposm2
x7	lda #$93
	sta hposm3
s4	lda #$00
	sta sizem
c4	lda #$00
	sta color3s
	
	lda PAL
	cmp #$0f
	bne PALDetected
	
c1n	lda #$38 ; NTSC
	sta color0s
c2n	lda #$FC
	sta color1s
c3n	lda #$24
	sta color2s
c5n	lda #$66
	sta colpm0s
;c6	lda #$56
	sta colpm1s
;c7	lda #$56
	sta colpm2s
;c8	lda #$56
	sta colpm3s
	jmp raster_program_end
	
PALDetected	
c1	lda #$18
	sta color0s
c2	lda #$EC
	sta color1s
c3	lda #$E4
	sta color2s
c5	lda #$56
	sta colpm0s
;c6	lda #$56
	sta colpm1s
;c7	lda #$56
	sta colpm2s
;c8	lda #$56
	sta colpm3s



raster_program_end

;	lda #$00
;	sta colpm0
;	sta colpm1
;	sta colpm2
;	sta colpm3
;	sta color0
;	sta color1
;	sta color2
;	sta color3
;	sta colbak

// -----------------------------------------------------------
//	EXIT
// -----------------------------------------------------------

;	lda trig0		; FIRE #0
;	beq stop
;
;	lda trig1		; FIRE #1
;	beq stop
;
;	lda consol		; START
;	and #1
;	beq stop
;
;	lda skctl		; ANY KEY
;	and #$04
;	bne skp
;
;stop	mva #$00 pmcntl		;PMG disabled
;	tax
;	sta:rne hposp0,x+
;
;	mva #$ff portb		;ROM switch on
;	mva #$40 nmien		;only NMI interrupts, DLI disabled
;	cli			;IRQ enabled

;	jmp *
	lda:cmp:req $14		;wait 1 frame

	rts			;return to ... DOS
;skp

// -----------------------------------------------------------

;	jmp LOOP

; ---

pmg equ $4000
	ift USESPRITES
;	.ALIGN $0800
;pmg	.ds $0300
	org $4300
	ift FADECHR = 0
	SPRITES
	els
	.ds $500
	eif
	eif


; ---

.MACRO	ANTIC_PROGRAM
	dta $70,$70,$70
	dta $4e,a(:1+$0000),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$0140),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$0280),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$03C0),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$0500),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$0640),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$0780),$e,$e,$e,$e,$e,$e,$e
	dta $70;dta $4e,a(:1+$08C0),$e,$e,$e,$e,$e,$e,$e
	dta $70;dta $4e,a(:1+$0A00),$e,$e,$e,$e,$e,$e,$e
	dta $70;dta $4e,a(:1+$0B40),$e,$e,$e,$e,$e,$e,$e
	
	dta $4e,a(:1+$08C0),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$0A00),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$0B40),$e,$e,$e,$e,$e,$e,$e
	
	;dta $70;dta $4e,a(:1+$0C80),$e,$e,$e,$e,$e,$e,$e
	;dta $70;dta $4e,a(:1+$0DC0),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$1000),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$1140),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$1280),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$13C0),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$1500),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$1640),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$1780),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$18C0),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$1A00),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$1B40),$e,$e,$e,$e,$e,$e,$e
	dta $4e,a(:1+$1C80),$e,$e,$e,$e,$e,$e,$e
	;dta $4e,a(:1+$1DC0),$e,$e,$e,$e,$e,$e,$e
	;dta $4e,a(:1+$2000),$e,$e,$e,$e,$e,$e,$e
	;dta $4e,a(:1+$2140),$e,$e,$e,$e,$e,$e,$e
	;dta $4e,a(:1+$2280),$e,$e,$e,$e,$e,$e,$e
	;dta $4e,a(:1+$23C0),$e,$e,$e,$e,$e,$e,$e
	;dta $4e,a(:1+$2500),$e,$e,$e,$e,$e,$e,$e
	;dta $4e,a(:1+$2640),$e,$e,$e,$e,$e,$e,$e
	dta $41,a(:2)
.ENDM

CL

.MACRO	ZPINIT
.ENDM

ZCOLORS	= 0

FADECHR	= 0
; ---
	ini main
; ---

	opt l-

.MACRO	SPRITES
missiles
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 03 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 12 30 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 01 03 03 03 03 03 03
	.he 0B 0B 04 00 00 10 20 20 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 80 80 80 80 80 00 00 00 40 40
	.he 00 00 00 40 00 00 40 40 40 40 40 C0 C0 80 80 80
	.he 80 80 80 80 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 20 20 10 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player0
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 01 00 01 00 01 01 01 01 01 00 00 00 00 00 00
	.he 00 01 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 01 07 0F 0F 1F 3F
	.he 73 40 80 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player1
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 F8 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 C0 E0 F8 FC FE FE FF
	.he F9 C0 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player2
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 01 01 03 02 06 04 04 08 08
	.he 08 10 10 10 20 20 20 20 00 40 40 00 00 40 40 00
	.he 00 80 40 80 40 80 80 40 80 40 C0 40 40 40 40 40
	.he 60 20 20 20 30 30 10 10 18 08 08 0C 04 06 02 03
	.he 01 01 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player3
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 80 40 00 20 10 10 08 08 04 04 04
	.he 02 02 03 01 01 01 01 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 01 01 01 01 03 03 06 05 06 0C 08 0C 18 10
	.he 30 20 40 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
.ENDM

USESPRITES = 1

